package cv08.server;

import cv08.server.action.*;

import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.*;

/**
 * Klient pripojeny k serveru
 *
 * @author Karel Cemus
 */
public class Client implements Runnable {

    /** network socket fo communication to the client */
    private final Socket socket;

    /** stream pro prijimani zprav od klienta */
    private final Scanner input;

    /** stream pro posilani zprav klientovi */
    private final DataOutputStream output;

    /** uzivatelova prezdivka */
    private String nickname;

    /** mistnosti, ve kterych klient je */
    private final Set<Room> rooms = new HashSet<Room>();

    public Client( Socket socket ) throws IOException {

        // socket pres ktery komunikujeme s uzivatelem
        this.socket = socket;

        // streamy pro posilani a cteni dat
        input = new Scanner( socket.getInputStream() );
        output = new DataOutputStream( socket.getOutputStream() );
    }

    /** odeslat klientovi zprávu */
    public boolean send( String message ) {
        // ToDo implement
        throw new UnsupportedOperationException("Not implemented yet");
    }

    /** uzivatel vstoupil do mistnosti */
    public void enterRoom( Room room ) {
        // ToDo implement
        throw new UnsupportedOperationException("Not implemented yet");
    }

    /** uzivatel opustil do mistnosti */
    public void leaveRoom( Room room ) {
        // ToDo implement
        throw new UnsupportedOperationException("Not implemented yet");
    }

    @Override
    public void run() {

        // nacist nick uzivatele
        // ToDo implement
        System.out.println( "Pripojen uzivatel s prezdivkou " + nickname );

        // dokud chodi prikazy, tak je budeme cist
        while ( input.hasNext() ) {

            // server se vypina, skoncime
            if ( Thread.currentThread().isInterrupted() ) break;

            // seznam podporovanych prikazu
            // ToDo implement
        }

        // pri ukoncovani uzivatel opousti vsechny mistnosti
        for ( Room room : rooms ){
            // ToDo implement
        }

        close();
    }

    public String getNickname() {
        return nickname;
    }

    private void close() {
        try {
            socket.close();
        } catch ( IOException e ) {}
    }
}
