package cv08.server.action;

import cv08.server.Client;
import cv08.server.Room;

/**
 * Akce pro odeslani zpravy v mistnosti
 *
 * @author Karel Cemus
 */
public class SendAction extends Action {

    private final String room;

    private final String text;

    public SendAction( Client client, String room, String text ) {
        super( client );
        this.room = room;
        this.text = text;
    }

    @Override
    public void execute() {
        if ( Room.get( room ) == null ) {
            client.send( "ERR Room does not exists." );
        } else if ( !Room.get( room ).contains( client ) ) {
            client.send( "ERR Not in room." );
        } else {
            Room.get( room ).send( client, text );
        }
    }
}
